

// Include the AccelStepper library:
//https://www.makerguides.com/wp-content/uploads/2019/02/AccelStepper-1.59.zip
// rev 01-09-2024 paulfjujo
#include "AccelStepper.h"

// Define stepper motor connections and motor interface type. Motor interface type must be set to 1 when using a driver:
#define dirPin 11
#define stepPin 10
#define EnPin 12
#define motorInterfaceType 1

// Create a new instance of the AccelStepper class:
AccelStepper stepper = AccelStepper(motorInterfaceType, stepPin, dirPin);

void setup() {
  pinMode(EnPin, OUTPUT);
  digitalWrite(EnPin, LOW);
  Serial.begin(19200);
  Serial.println("\r\n");
  Serial.println(" Version 01/09/2024   Arduino_Pro_Mini_Accelsetpper_Nema23.ino, rev paulfjujo");
  Serial.println(" Check NEMA23  TB6650 Arduino Pro Mini pins : En=12,Clck=10,Dir=11");
  Serial.println(" Usage de la lib Accelstepper 1-59\r\n");
   Serial.println(" Max speed :8000  Acceleartion :250\r\n");
  Serial.println("EnPin doit etre a l'etat HAUT pour valider la rotation ! \r\n");
  delay(1000); 
  digitalWrite(EnPin, HIGH);

  // Set the maximum speed and acceleration:
  stepper.setMaxSpeed(1000);
  stepper.setAcceleration(250);
}

void loop() {
  // Set the target position:
  Serial.println(" Start");
  digitalWrite(EnPin, HIGH);
  Serial.println(" Move to position 8000 ..");
  // Run to target position with set speed and acceleration/deceleration:
  stepper.moveTo(8000);
  stepper.runToPosition();
  digitalWrite(EnPin, LOW);
  Serial.println(" Stop");
  delay(2000);
  Serial.println(" Start");
  digitalWrite(EnPin, HIGH);
  Serial.println(" Move Back to position  zero");
  stepper.moveTo(0);
  stepper.runToPosition();
  digitalWrite(EnPin, LOW);
  Serial.println(" Stop");
  delay(2000);
}


/*
 * C:\Program Files (x86)\Arduino\arduino-builder -dump-prefs -logger=machine -hardware C:\Program Files (x86)\Arduino\hardware -hardware C:\Users\Paul\AppData\Local\Arduino15\packages -hardware C:\Users\Paul\AppData\Local\Arduino15\hardware -tools C:\Program Files (x86)\Arduino\tools-builder -tools C:\Program Files (x86)\Arduino\hardware\tools\avr -tools C:\Users\Paul\AppData\Local\Arduino15\packages -built-in-libraries C:\Program Files (x86)\Arduino\libraries -libraries C:\Users\Paul\AppData\Local\Arduino15\libraries -fqbn=arduino:avr:pro:cpu=16MHzatmega328 -vid-pid=067B_2303 -ide-version=10819 -build-path C:\Users\Paul\AppData\Local\Temp\arduino_build_143779 -warnings=all -prefs=build.warn_data_percentage=75 -verbose D:\_Arduino_Pro_mini_2022\Arduino_Pro_Mini_Accelsetpper_Nema23\Arduino_Pro_Mini_Accelsetpper_Nema23.ino
C:\Program Files (x86)\Arduino\arduino-builder -compile -logger=machine -hardware C:\Program Files (x86)\Arduino\hardware -hardware C:\Users\Paul\AppData\Local\Arduino15\packages -hardware C:\Users\Paul\AppData\Local\Arduino15\hardware -tools C:\Program Files (x86)\Arduino\tools-builder -tools C:\Program Files (x86)\Arduino\hardware\tools\avr -tools C:\Users\Paul\AppData\Local\Arduino15\packages -built-in-libraries C:\Program Files (x86)\Arduino\libraries -libraries C:\Users\Paul\AppData\Local\Arduino15\libraries -fqbn=arduino:avr:pro:cpu=16MHzatmega328 -vid-pid=067B_2303 -ide-version=10819 -build-path C:\Users\Paul\AppData\Local\Temp\arduino_build_143779 -warnings=all -prefs=build.warn_data_percentage=75 -verbose D:\_Arduino_Pro_mini_2022\Arduino_Pro_Mini_Accelsetpper_Nema23\Arduino_Pro_Mini_Accelsetpper_Nema23.ino
Using board 'pro' from platform in folder: C:\Users\Paul\AppData\Local\Arduino15\packages\arduino\hardware\avr\1.8.6
Using core 'arduino' from platform in folder: C:\Users\Paul\AppData\Local\Arduino15\packages\arduino\hardware\avr\1.8.6
Detecting libraries used...
"C:\\Program Files (x86)\\Arduino\\hardware\\tools\\avr/bin/avr-g++" -c -g -Os -w -std=gnu++11 -fpermissive -fno-exceptions -ffunction-sections -fdata-sections -fno-threadsafe-statics -Wno-error=narrowing -flto -w -x c++ -E -CC -mmcu=atmega328p -DF_CPU=16000000L -DARDUINO=10819 -DARDUINO_AVR_PRO -DARDUINO_ARCH_AVR "-IC:\\Users\\Paul\\AppData\\Local\\Arduino15\\packages\\arduino\\hardware\\avr\\1.8.6\\cores\\arduino" "-IC:\\Users\\Paul\\AppData\\Local\\Arduino15\\packages\\arduino\\hardware\\avr\\1.8.6\\variants\\eightanaloginputs" "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779\\sketch\\Arduino_Pro_Mini_Accelsetpper_Nema23.ino.cpp" -o nul
Alternatives for AccelStepper.h: [AccelStepper]
ResolveLibrary(AccelStepper.h)
  -> candidates: [AccelStepper]
"C:\\Program Files (x86)\\Arduino\\hardware\\tools\\avr/bin/avr-g++" -c -g -Os -w -std=gnu++11 -fpermissive -fno-exceptions -ffunction-sections -fdata-sections -fno-threadsafe-statics -Wno-error=narrowing -flto -w -x c++ -E -CC -mmcu=atmega328p -DF_CPU=16000000L -DARDUINO=10819 -DARDUINO_AVR_PRO -DARDUINO_ARCH_AVR "-IC:\\Users\\Paul\\AppData\\Local\\Arduino15\\packages\\arduino\\hardware\\avr\\1.8.6\\cores\\arduino" "-IC:\\Users\\Paul\\AppData\\Local\\Arduino15\\packages\\arduino\\hardware\\avr\\1.8.6\\variants\\eightanaloginputs" "-IC:\\Users\\Paul\\AppData\\Local\\Arduino15\\libraries\\AccelStepper" "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779\\sketch\\Arduino_Pro_Mini_Accelsetpper_Nema23.ino.cpp" -o nul
Using cached library dependencies for file: C:\Users\Paul\AppData\Local\Arduino15\libraries\AccelStepper\AccelStepper.cpp
Using cached library dependencies for file: C:\Users\Paul\AppData\Local\Arduino15\libraries\AccelStepper\MultiStepper.cpp
Generating function prototypes...
"C:\\Program Files (x86)\\Arduino\\hardware\\tools\\avr/bin/avr-g++" -c -g -Os -w -std=gnu++11 -fpermissive -fno-exceptions -ffunction-sections -fdata-sections -fno-threadsafe-statics -Wno-error=narrowing -flto -w -x c++ -E -CC -mmcu=atmega328p -DF_CPU=16000000L -DARDUINO=10819 -DARDUINO_AVR_PRO -DARDUINO_ARCH_AVR "-IC:\\Users\\Paul\\AppData\\Local\\Arduino15\\packages\\arduino\\hardware\\avr\\1.8.6\\cores\\arduino" "-IC:\\Users\\Paul\\AppData\\Local\\Arduino15\\packages\\arduino\\hardware\\avr\\1.8.6\\variants\\eightanaloginputs" "-IC:\\Users\\Paul\\AppData\\Local\\Arduino15\\libraries\\AccelStepper" "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779\\sketch\\Arduino_Pro_Mini_Accelsetpper_Nema23.ino.cpp" -o "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779\\preproc\\ctags_target_for_gcc_minus_e.cpp"
"C:\\Program Files (x86)\\Arduino\\tools-builder\\ctags\\5.8-arduino11/ctags" -u --language-force=c++ -f - --c++-kinds=svpf --fields=KSTtzns --line-directives "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779\\preproc\\ctags_target_for_gcc_minus_e.cpp"
Compiling sketch...
"C:\\Program Files (x86)\\Arduino\\hardware\\tools\\avr/bin/avr-g++" -c -g -Os -Wall -Wextra -std=gnu++11 -fpermissive -fno-exceptions -ffunction-sections -fdata-sections -fno-threadsafe-statics -Wno-error=narrowing -MMD -flto -mmcu=atmega328p -DF_CPU=16000000L -DARDUINO=10819 -DARDUINO_AVR_PRO -DARDUINO_ARCH_AVR "-IC:\\Users\\Paul\\AppData\\Local\\Arduino15\\packages\\arduino\\hardware\\avr\\1.8.6\\cores\\arduino" "-IC:\\Users\\Paul\\AppData\\Local\\Arduino15\\packages\\arduino\\hardware\\avr\\1.8.6\\variants\\eightanaloginputs" "-IC:\\Users\\Paul\\AppData\\Local\\Arduino15\\libraries\\AccelStepper" "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779\\sketch\\Arduino_Pro_Mini_Accelsetpper_Nema23.ino.cpp" -o "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779\\sketch\\Arduino_Pro_Mini_Accelsetpper_Nema23.ino.cpp.o"
Compiling libraries...
Compiling library "AccelStepper"
Using previously compiled file: C:\Users\Paul\AppData\Local\Temp\arduino_build_143779\libraries\AccelStepper\MultiStepper.cpp.o
Using previously compiled file: C:\Users\Paul\AppData\Local\Temp\arduino_build_143779\libraries\AccelStepper\AccelStepper.cpp.o
Compiling core...
Using previously compiled file: C:\Users\Paul\AppData\Local\Temp\arduino_build_143779\core\wiring_pulse.S.o
...etc ...
Using previously compiled file: C:\Users\Paul\AppData\Local\Temp\arduino_build_143779\core\main.cpp.o
Using previously compiled file: C:\Users\Paul\AppData\Local\Temp\arduino_build_143779\core\core.a
Linking everything together...
"C:\\Program Files (x86)\\Arduino\\hardware\\tools\\avr/bin/avr-gcc" -Wall -Wextra -Os -g -flto -fuse-linker-plugin -Wl,--gc-sections -mmcu=atmega328p -o "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779/Arduino_Pro_Mini_Accelsetpper_Nema23.ino.elf" "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779\\sketch\\Arduino_Pro_Mini_Accelsetpper_Nema23.ino.cpp.o" "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779\\libraries\\AccelStepper\\AccelStepper.cpp.o" "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779\\libraries\\AccelStepper\\MultiStepper.cpp.o" "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779/core\\core.a" "-LC:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779" -lm
"C:\\Program Files (x86)\\Arduino\\hardware\\tools\\avr/bin/avr-objcopy" -O ihex -j .eeprom --set-section-flags=.eeprom=alloc,load --no-change-warnings --change-section-lma .eeprom=0 "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779/Arduino_Pro_Mini_Accelsetpper_Nema23.ino.elf" "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779/Arduino_Pro_Mini_Accelsetpper_Nema23.ino.eep"
"C:\\Program Files (x86)\\Arduino\\hardware\\tools\\avr/bin/avr-objcopy" -O ihex -R .eeprom "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779/Arduino_Pro_Mini_Accelsetpper_Nema23.ino.elf" "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779/Arduino_Pro_Mini_Accelsetpper_Nema23.ino.hex"
Using library AccelStepper in folder: C:\Users\Paul\AppData\Local\Arduino15\libraries\AccelStepper (legacy)
"C:\\Program Files (x86)\\Arduino\\hardware\\tools\\avr/bin/avr-size" -A "C:\\Users\\Paul\\AppData\\Local\\Temp\\arduino_build_143779/Arduino_Pro_Mini_Accelsetpper_Nema23.ino.elf"
Sketch uses 6858 bytes (22%) of program storage space. Maximum is 30720 bytes.
Global variables use 556 bytes (27%) of dynamic memory, leaving 1492 bytes for local variables. Maximum is 2048 bytes.
C:\Users\Paul\AppData\Local\Arduino15\packages\arduino\tools\avrdude\6.3.0-arduino17/bin/avrdude -CC:\Users\Paul\AppData\Local\Arduino15\packages\arduino\tools\avrdude\6.3.0-arduino17/etc/avrdude.conf -v -patmega328p -carduino -PCOM25 -b57600 -D -Uflash:w:C:\Users\Paul\AppData\Local\Temp\arduino_build_143779/Arduino_Pro_Mini_Accelsetpper_Nema23.ino.hex:i 

avrdude: Version 6.3-20190619
         Copyright (c) 2000-2005 Brian Dean, http://www.bdmicro.com/
         Copyright (c) 2007-2014 Joerg Wunsch

         System wide configuration file is "C:\Users\Paul\AppData\Local\Arduino15\packages\arduino\tools\avrdude\6.3.0-arduino17/etc/avrdude.conf"

         Using Port                    : COM25
         Using Programmer              : arduino
         Overriding Baud Rate          : 57600
         AVR Part                      : ATmega328P
         Chip Erase delay              : 9000 us
         PAGEL                         : PD7
         BS2                           : PC2
         RESET disposition             : dedicated
         RETRY pulse                   : SCK
         serial program mode           : yes
         parallel program mode         : yes
         Timeout                       : 200
         StabDelay                     : 100
         CmdexeDelay                   : 25
         SyncLoops                     : 32
         ByteDelay                     : 0
         PollIndex                     : 3
         PollValue                     : 0x53
         Memory Detail                 :

                                  Block Poll               Page                       Polled
           Memory Type Mode Delay Size  Indx Paged  Size   Size #Pages MinW  MaxW   ReadBack
           ----------- ---- ----- ----- ---- ------ ------ ---- ------ ----- ----- ---------
           eeprom        65    20     4    0 no       1024    4      0  3600  3600 0xff 0xff
           flash         65     6   128    0 yes     32768  128    256  4500  4500 0xff 0xff
           lfuse          0     0     0    0 no          1    0      0  4500  4500 0x00 0x00
           hfuse          0     0     0    0 no          1    0      0  4500  4500 0x00 0x00
           efuse          0     0     0    0 no          1    0      0  4500  4500 0x00 0x00
           lock           0     0     0    0 no          1    0      0  4500  4500 0x00 0x00
           calibration    0     0     0    0 no          1    0      0     0     0 0x00 0x00
           signature      0     0     0    0 no          3    0      0     0     0 0x00 0x00

         Programmer Type : Arduino
         Description     : Arduino
         Hardware Version: 2
         Firmware Version: 1.16
         Vtarget         : 0.0 V
         Varef           : 0.0 V
         Oscillator      : Off
         SCK period      : 0.1 us

avrdude: AVR device initialized and ready to accept instructions

Reading | ################################################## | 100% -0.00s

avrdude: Device signature = 0x1e950f (probably m328p)
avrdude: reading input file "C:\Users\Paul\AppData\Local\Temp\arduino_build_143779/Arduino_Pro_Mini_Accelsetpper_Nema23.ino.hex"
avrdude: writing flash (6858 bytes):

Writing | ################################################## | 100% 1.87s

avrdude: 6858 bytes of flash written
avrdude: verifying flash memory against C:\Users\Paul\AppData\Local\Temp\arduino_build_143779/Arduino_Pro_Mini_Accelsetpper_Nema23.ino.hex:
avrdude: load data flash data from input file C:\Users\Paul\AppData\Local\Temp\arduino_build_143779/Arduino_Pro_Mini_Accelsetpper_Nema23.ino.hex:
avrdude: input file C:\Users\Paul\AppData\Local\Temp\arduino_build_143779/Arduino_Pro_Mini_Accelsetpper_Nema23.ino.hex contains 6858 bytes
avrdude: reading on-chip flash data:

Reading | ################################################## | 100% 1.33s

avrdude: verifying ...
avrdude: 6858 bytes of flash verified
avrdude done.  Thank you
*.
 */
